#line 1 "f:/Razvoj/EasyPIC-SMT/1/MultitaskingNoInterrupt.c"
#line 44 "f:/Razvoj/EasyPIC-SMT/1/MultitaskingNoInterrupt.c"
typedef struct
{
 unsigned char B0:1;
 unsigned char B1:1;
 unsigned char B2:1;
 unsigned char B3:1;
 unsigned char B4:1;
 unsigned char B5:1;
 unsigned char B6:1;
 unsigned char B7:1;
} PORT;

char PORTAlias at PORTB;
PORT PORTC_OLD;



sbit bTask0 at PORTB.B0;
sbit bTask1 at PORTB.B1;
sbit bPWM at PORTB.B2;
sbit bRed at PORTB.B7;
sbit bYellow at PORTB.B6;
sbit bGreen at PORTB.B5;

sbit bSemStop at PORTC.B0;
sbit bSemStart at PORTC.B1;
sbit bSemStopOld at PORTC_OLD.B0;
sbit bSemStartOld at PORTC_OLD.B1;

unsigned cnt;

struct task
{
 unsigned char id;
 unsigned char state;
 int tick;
 int interval;
} tasks[ 8 ];





enum { START, STOP, OFF, ON, TICKING, TICKED, RED, REDYELLOW, GREEN, YELLOW, IDLE };

void ticker()
{
 int i;
 for(i=0; i< 8 ; i++)
 {
 if(tasks[i].tick > 0) tasks[i].tick--;
 }
}
#line 108 "f:/Razvoj/EasyPIC-SMT/1/MultitaskingNoInterrupt.c"
void ftask0(struct task *pt)
{
 switch(pt->state){
 case TICKING:
 if(pt->tick > 0) break;
 else pt->state=TICKED;
 case TICKED:

 bTask0=~bTask0;
 pt->tick=pt->interval;
 pt->state=TICKING;
 break;
 case IDLE: break;
 default: break;
 }
}

void ftask1(struct task *pt)
{
 switch(pt->state){
 case TICKING:
 if(pt->tick > 0) break;
 else pt->state=TICKED;
 case TICKED:

 bTask1=~bTask1;
 pt->tick=pt->interval;
 pt->state=TICKING;
 break;
 case IDLE: break;
 default: break;
 }
}

void pwm(struct task *pt)
{
 switch(pt->state){
 case ON:
 if(pt->tick > 0) break;
 else {


 bPWM=1;
 pt->tick=100;
 pt->state=OFF;
 }
 break;
 case OFF:
 if(pt->tick > 0) break;
 else {

 bPWM=0;
 pt->tick=300;
 pt->state=ON;
 }
 case IDLE: break;
 default: break;
 }
}

void traffic_lights(struct task *pt)
{
 switch(pt->state){
 case RED:
 if(pt->tick > 0) break;
 else {

 bRed=1; bYellow=0;
 pt->tick=300;
 pt->state=REDYELLOW;
 }
 break;
 case REDYELLOW:
 if(pt->tick > 0) break;
 else {

 bYellow=1;
 pt->tick=100;
 pt->state=GREEN;
 }
 case GREEN:
 if(pt->tick > 0) break;
 else {

 bRed=0; bYellow=0; bGreen=1;
 pt->tick=300;
 pt->state=YELLOW;
 }
 break;
 case YELLOW:
 if(pt->tick > 0) break;
 else {

 bGreen=0; bYellow=1;
 pt->tick=100;
 pt->state=RED;
 }
 break;
 case IDLE: break;
 default: break;
 }
}


void port_poll(struct task *pt)
{
 switch(pt->state)
 {
 case IDLE:
 if(bSemStopOld==0 && bSemStop==1) {
 bRed=bYellow=bGreen=0;
 tasks[2].tick=0;
 tasks[2].state=IDLE;
 }
 if(bSemStartOld==0 && bSemStart==1) {
 bRed=bYellow=bGreen=0;
 tasks[2].tick=tasks[2].interval;
 tasks[2].state=RED;
 }
 break;
 default: break;
 }
}

void task_init(int i, int state, int tick, int counter)
{
 tasks[i].id=i;
 tasks[i].state=state;
 tasks[i].tick=tick;
 tasks[i].interval=tasks[i].tick;
}


void bsp_init(void)
{

 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 TRISB = 0;
 PORTB = 0x00;
 TRISC = 0x03;



}

void main() {
 cnt = 0;
 bsp_init();

 task_init(0, TICKING, 100, 0);
 task_init(1, TICKING, 200, 0);
 task_init(2, RED, 0, 0);
 task_init(3, OFF, 0, 0);
 task_init(4, IDLE, 10, 0);


 while(1) {
 ftask0(&tasks[0]);
 ftask1(&tasks[1]);
 traffic_lights(&tasks[2]);
 pwm(&tasks[3]);
 port_poll(&tasks[4]);
 if (cnt >= 4) {
 ticker();
 cnt = 0;
 memcpy(&PORTC_OLD, &PORTC, 1);
 }
 delay_us(2500);
 cnt++;
 }
}
